package com.example.workflow;
import jakarta.inject.Named;
import javax.inject.Inject;
import org.camunda.bpm.engine.delegate.DelegateExecution;
import org.camunda.bpm.engine.delegate.JavaDelegate;
import org.springframework.jdbc.core.JdbcTemplate;


@Named
public class UpdateStatusToCompleted implements JavaDelegate{
    @Inject
    private JdbcTemplate jdbcTemplate;

    @Override
    public void execute(DelegateExecution execution) {
        // Put the logic here
        try {
            // 1. Find the most recent ticket's ID
            String findMostRecentTicketIdSql = "SELECT ID FROM TICKET_SUBMISSION ORDER BY ID DESC LIMIT 1";
            Integer mostRecentTicketId = jdbcTemplate.queryForObject(findMostRecentTicketIdSql, Integer.class);

            if (mostRecentTicketId != null) {
                // 2. Update the status of the most recent ticket
                String updateStatusSql = "UPDATE TICKET_SUBMISSION SET STATUS = 'Completed' WHERE ID = ?";
                int rowsAffected = jdbcTemplate.update(updateStatusSql, mostRecentTicketId);

                if (rowsAffected > 0) {
                    System.out.println("Ticket status updated to Completed for ticket with ID " + mostRecentTicketId);
                } else {
                    System.out.println("No update performed. It's possible the ticket with ID " + mostRecentTicketId + " was already updated or does not exist.");
                }
            } else {
                System.out.println("No recent ticket found to update.");
            }
        } catch (Exception e) {
            // Handle any exceptions here
            System.out.println("An error occurred: " + e.getMessage());
            e.printStackTrace();
        }
    }

}
